//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
// STEAR 2010
//--------------------------------------------------------------
// freeze owataBGMt@C[x[Xɂ摜r[B
//--------------------------------------------------------------

#include <pspdisplay.h>
#include <pspkernel.h>
#include <pspsdk.h>
#include <psppower.h>
#include <stdio.h>
#include <string.h>
#include "psp2ch.h"
#include "pg.h"
#include "psp2chMenu.h"
#include "psp2chAudio.h"

//------ 萔 -----

#define	VERSION		(0.51)

//------ s[hw -----

PSP_MODULE_INFO("freeze viewer", PSP_MODULE_USER, 0, 8);
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER);
PSP_HEAP_SIZE_KB(-2048);

extern S_2CH s2ch; // psp2ch.c
volatile int	gExitRequest = 0;								// PSP
void SMEMOinit(void);											// PSP
void SMEMOend(void);											// PSP


//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;											// PSP
	s2ch.running = 0;
	sceKernelExitGame();
	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int power_callback(int unknown, int pwrflags, void *common)
{
	/* check for power switch and suspending as one is manual and the other automatic */
	if (pwrflags & PSP_POWER_CB_POWER_SWITCH || pwrflags & PSP_POWER_CB_SUSPENDING) {
		psp2chAudioStop();
	} else if (pwrflags & PSP_POWER_CB_RESUMING) {
	} else if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE) {
	} else if (pwrflags & PSP_POWER_CB_STANDBY) {
	} else {
	}
	sceDisplayWaitVblankStart();

	return 0;
}

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	cbid = sceKernelCreateCallback("Power Callback", power_callback, NULL);
	scePowerRegisterCallback(0, cbid);
	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0x0FA0, 0, 0);
	if (thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}
	return thid;
}


//==============================================================
// main
//--------------------------------------------------------------

int main(int argc, char *argv[])
{
	char *ch,msg[32];

	strcpy(s2ch.cwDir, argv[0]);
	ch = strrchr(s2ch.cwDir, '/');
	*ch = '\0';
	SetupCallbacks();
	// Rg[n̐ݒ
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	SMEMOinit();												// PSP
	if (psp2chInit() != 0){										// tHg[h̊֌W瑁߂Ɏs
		goto END;
	}
	pgFontLoad();												// tHg[hɎsŋI
	pgCreateTexture();
	pgSetupGu();
	pgSetDrawStart(10, 0, 0, 0);
	sprintf(msg, "freeze viewer ver%-3.2f   By.STEAR 2010", VERSION);
	pgPrint(msg, WHITE, WHITE, SCR_WIDTH);
	pgCopy(0,0);
	flipScreen(0);
	pgCopy(0,0);

	if (psp2chAudioInit() < 0){
		goto END;
	}

	psp2chMenuPlayer( s2ch.cfg.imageDir );

	SMEMOend();													// PSP
END:
	pgDeleteTexture();
	pgFontUnload();
	pgTermGu();
	psp2chAudioTerm();
	sceKernelExitGame();
	return 0;
}
