/*
* $Id: psp2ch.c 157 2008-09-16 23:13:56Z bird_may_nike $
*/

#include "psp2ch.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <psputility.h>
#include <psprtc.h>
#include "psp2chMenu.h"
#include "psp2chIni.h"
#include "utf8.h"
#include "pg.h"
#include "charConv.h"
#include "psp2chAudio.h"
#include "smemo/draw.h"
#include "smemo/strInput.h"
#include "smemo/sime.h"
#include "smemo/graphics.h"

#define BOX_BG_COLOR 116
#define BOX_TEXT_BG_COLOR 117

extern const char* colorFile; // psp2chMenu.c
extern Window_Layer *winParam;

S_2CH s2ch;
char keyWords[128];
const char searchWords[] = "searchHistory.dat";

// prototype
int psp2chInputKana(char* buf, unsigned int max);
static void psp2chStart(void);


/*****************************
X^[g
*****************************/

static void psp2chStart(void)
{
	pgFillvram(FORM_INDEX + 3, 0, 0, SCR_WIDTH, SCR_HEIGHT, 2);
	pgSetDrawStart(0, 0, 0, 0);
	pgPrint("Freeze Owata+1 based Freeze Owata(by KMA) rev 100331", RED, WHITE, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH*2);
	pgPrint("Freeze Owata based owata browser(by toyo) rev 161", WHITE, WHITE, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("used libraries: Many thanks!!", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libCat Copyright (c) 2008 SofiyaL", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libjpeg@Copyright (c) 1991-1998, Thomas G. Lane.", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  zlib@Copyright (c) 1995-2004 Jean-loup Gailly and Mark Adler.", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libpng@Copyright (c) 1998-2004 Glenn Randers-Pehrson.", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libungif 4.1.4 Copyright (c) 1997  Eric S. Raymond", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  S 5.9.0 Copyright (c) 2002-2006  K.Kosako", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  S 5.9.0 for PSP Copyright (c) 2007 NIPS", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH*2);
	pgPrint("PSP Ver1.09 By.STEAR 2009-2010", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH*2);
	pgPrint("START: ", GREEN, BLACK, SCR_WIDTH);
	pgSetDrawStart(50, -1, 0, 0);
	pgPrint("view category list", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("CIRCLE: ", GREEN, BLACK, SCR_WIDTH);
	pgSetDrawStart(50, -1, 0, 0);
	pgPrint("favorite thread list", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("CROSS: ", GREEN, BLACK, SCR_WIDTH);
	pgSetDrawStart(50, -1, 0, 0);
	pgPrint("exit", WHITE, BLACK, SCR_WIDTH);
    if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
    {
        if(s2ch.pad.Buttons & PSP_CTRL_CROSS)
        {
//            if (psp2chOwata())
            {
                return;
            }
        }
        else if(s2ch.pad.Buttons & PSP_CTRL_START)
        {
            s2ch.sel = 2;
            return;
        }
        else if(s2ch.pad.Buttons & PSP_CTRL_CIRCLE)
        {
            s2ch.sel = 1;
            return;
        }
    }
    pgCopy(0, 0);
}

/*****************************
J[\ړ[`
S_2CH_SCREEN\̂
start:\Jns
select:J[\Is
ύXR{^Ԃ
*****************************/
int psp2chCursorSet(S_2CH_SCREEN* line, int lineEnd, int shift, int pad, int* change)
{
    static int keyStart = 0, keyRepeat = 0;
    static clock_t keyTime = 0;
    int rMenu, start, select;
    int padUp = 0, padDown = 0;

	*change = 0;
	rMenu = s2ch.pad.Buttons & shift;
    if (winParam->tateFlag)
    {
        if (s2ch.pad.Lx == 255)
        {
            padUp = 1;
        }
        else if (s2ch.pad.Lx == 0)
        {
            padDown = 1;
        }
    }
    else
    {
        if (s2ch.pad.Ly == 0)
        {
            padUp = 1;
        }
        else if (s2ch.pad.Ly == 255)
        {
            padDown = 1;
        }
    }

	start = line->start;
	select = line->select;
	if (padUp)
	{
        line->select--;
		if (line->start)
		{
			line->start--;
		}
	}
	else if (padDown)
	{
        line->select++;
		if (line->start < (line->count - lineEnd))
		{
			line->start++;
		}
	}

    if (s2ch.pad.Buttons != s2ch.oldPad.Buttons || keyRepeat)
    {
        if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
        {
            keyStart = 1;
        }
        else
        {
            keyStart = 0;
        }
        keyTime = sceKernelLibcClock();
        keyRepeat = 0;
        if (s2ch.pad.Buttons & s2ch.listB[winParam->tateFlag].up)
        {
            line->select--;
            if (line->select < line->start)
            {
                line->start = line->select;
            }
        }
        else if (s2ch.pad.Buttons & s2ch.listB[winParam->tateFlag].down)
        {
            line->select++;
            if (line->select >= line->start + lineEnd)
            {
                line->start = line->select - lineEnd + 1;
            }
        }
        else if (s2ch.pad.Buttons & s2ch.listB[winParam->tateFlag].pUp)
        {
            if (line->select == line->start)
            {
                line->start -= lineEnd;
            }
            line->select = line->start;
        }
        else if (s2ch.pad.Buttons & s2ch.listB[winParam->tateFlag].pDown)
        {
            if (line->select == line->start + lineEnd - 1)
            {
                line->start += lineEnd;
            }
            line->select = line->start + lineEnd - 1;
        }
        // top, end
        if (s2ch.pad.Buttons & s2ch.listB[winParam->tateFlag].top)
        {
            if (rMenu && !padUp)
            {
                line->start = 0;
                line->select = 0;
            }
        }
        else if (s2ch.pad.Buttons & s2ch.listB[winParam->tateFlag].end)
        {
            if (rMenu && !padDown)
            {
                line->start = line->count - lineEnd;
                line->select = line->count - 1;
            }
        }
    }
    else
    {
        if (keyStart)
        {
            if (sceKernelLibcClock() - keyTime > 400000)
            {
                keyRepeat = 1;
            }
        }
        else
        {
            if (sceKernelLibcClock() - keyTime > 1000)
            {
                keyRepeat = 1;
            }
        }
    }
    if (pad)
    {
    	int ret;
    	ret = psp2chPadSet(winParam->viewX);
    	if (ret != winParam->viewX)
    	{
    		winParam->viewX = ret;
    		*change = 1;
    	}
    }
    
    // ͈͊O̕␳
    if (line->start < 0) {
    	line->start = 0;
    }
    else if (line->start + lineEnd >= line->count) {
    	line->start = line->count - lineEnd;
    }
    if (line->select < 0) {
    	line->select = 0;
    }
    else if (line->select >= line->count) {
    	line->select = line->count - 1;
    }
    
	if (start != line->start || select != line->select)
	{
		*change = 1;
	}
    return rMenu;
}

/*****************************
AiOpbhŉXN[
s2ch.cfg.xReverse-1ɂƃXN[]
*****************************/
int psp2chPadSet(int scrollX)
{
    if (winParam->tateFlag)
    {
        if (s2ch.pad.Ly == 0)
        {
            scrollX += 8 * s2ch.cfg.padReverse;
        }
        else if (s2ch.pad.Ly == 255)
        {
            scrollX -= 8 * s2ch.cfg.padReverse;
        }
        if (scrollX > BUF_HEIGHT * 2 - SCR_HEIGHT)
        {
            scrollX = BUF_HEIGHT * 2 - SCR_HEIGHT;
        }
    }
    else
    {
        if (s2ch.pad.Lx == 0)
        {
            scrollX += 4 * s2ch.cfg.padReverse;
        }
        else if (s2ch.pad.Lx == 255)
        {
            scrollX -= 4 * s2ch.cfg.padReverse;
        }
        if (scrollX > BUF_WIDTH * 2 - SCR_WIDTH)
        {
            scrollX = BUF_WIDTH * 2 - SCR_WIDTH;
        }
    }
    if (scrollX < 0)
    {
        scrollX = 0;
    }
    return scrollX;
}

/***********************************
W[̃[h

************************************/
int psp2chInit(void)
{
	const char *sBtnH[] = {"Sel", "", "", "St", "", "", "", "", "L", "R", "", "", "", "", "~", "", ""};
	const char *sBtnV[] = {"Sel", "", "", "St", "", "", "", "", "L", "R", "", "", "", "", "~", "", ""};

    psp2chIniSetColor((char*)colorFile);
    psp2chIniSetButtons();
    psp2chMenuSetMenuString(sBtnH, sBtnV);
    psp2chIniLoadConfig();
    s2ch.running = 1;
    s2ch.sel = 0;
	psp2chSetFontParam();
	psp2chSetBarParam();
	pgCursorColorSet();

    return 0;
}

/*****************************
OnScreenKeyboardŕ
title: OSK̉Eɕ\^Cg(SJIS)
text:͕ۑ|C^
num:͕̒
lines:͕̍s
OSK̓Ch(UCS)ŋAĂ̂SJISɕϊĂ܂B
*****************************/
void psp2chGets(char* title, char* text, int num, int lines)
{
    unsigned char* p;
    unsigned short string[128];
    unsigned short pretext[RES_MESSAGE_LENGTH], text_buf[RES_MESSAGE_LENGTH];
    int running = 0;
    char* buf = "l_(^o^)^";

    if (num > RES_MESSAGE_LENGTH)
    {
        num = RES_MESSAGE_LENGTH;
    }
    /* sjis => ucs */
    if (title && *title != '\0')
    {
        p = (unsigned char*)title;
    }
    else
    {
        p = (unsigned char*)buf;
    }
    psp2chSJIS2UCS(string, p, 127);
    p = (unsigned char*)text;
    psp2chSJIS2UCS(pretext, p, RES_MESSAGE_LENGTH);
    
    SceUtilityOskData data;
    SceUtilityOskParams param;
    
    memset(&data, 0, sizeof(data));
    data.language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
    data.unk_00 = 1;
    data.unk_04 = 0;
    data.language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
    data.unk_12 = 0;
    data.inputtype = PSP_UTILITY_OSK_INPUTTYPE_ALL;
    data.lines = lines;
    data.unk_24 = 1;
    data.desc = string;
    data.intext = pretext;
    data.outtext = text_buf;
    data.outtextlength = num;
    data.outtextlimit = num;
    
    memset(&param, 0, sizeof(param));
    param.base.size = sizeof(param);
    sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &param.base.language);
    sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &param.base.buttonSwap);
    param.base.graphicsThread = 0x11;
    param.base.accessThread = 0x13;
    param.base.fontThread = 0x12;
    param.base.soundThread = 0x10;
    param.datacount = 1;
    param.data = &data;
	
	sceUtilityOskInitStart(&param);
	
	while(!running) {
		pgGuRender();
		
		switch(sceUtilityOskGetStatus()) {
			case PSP_UTILITY_DIALOG_NONE :
				running = 1;
				break;
			case PSP_UTILITY_DIALOG_VISIBLE :
				pgWaitVn(1);
				sceUtilityOskUpdate(2);
				break;
			case PSP_UTILITY_DIALOG_QUIT :
				sceUtilityOskShutdownStart();
				break;
			default:
				break;
		}
		flipScreen(0);
	}

    /* ucs => sjis */
    psp2chUCS2SJIS((unsigned char*)text, text_buf, num);
}

//==============================================================
// Simple IMEɂ镶
//--------------------------------------------------------------
// ۂ̏PSP͂̕ōsĂ܂B
//--------------------------------------------------------------

static int psp2chLInput(char *title, char *pretext, int type)
{
	char		file[FILE_PATH];
	int			ret;
	strInpHis	**inphis;
	SceCtrlData	pad;

	sprintf(file, "%s/%s", s2ch.cwDir, searchWords);
	inphis = InputHisLoad( file );								// 擾
	keyWords[0] = '\0';
	if(pretext != NULL){
		strncpy(keyWords, pretext, sizeof(keyWords)-1);
	}

	initGraphics();												// PSPp惂[h
	flipScreen2();												// ftHgł̓y[Wݒɕsŝ
	sceCtrlPeekBufferPositive(&pad, 1);
	SIMEgetchar(pad);											// Simple IMȄ͑΍
	ret = InputName(title, 50, type, keyWords, keyWords, inphis);
	if (!ret){													// ̏ꍇ͗Ɍo^
		InputHisAdd(inphis, keyWords);
		InputHisSave(file, inphis);
	}
	pad.Buttons = 0;
	SIMEgetchar(pad);											// Simple IMENɂȂL[s[gȂ悤
	InputHisFree(inphis);										// 폜
	pgSetupGu();												// t[YI^p惂[h
	sceCtrlPeekBufferPositive(&s2ch.pad, 1);
	s2ch.oldPad = s2ch.pad;										// ̌̃L[͎̃L[s[g΍

	return ret;
}

/****************
̓_CAO\
text1: _CAOɕ\^Cg
text2: OSKɕ\^Cg
߂l 0=, -1=
keyWords[]ɕ񂪕Ԃ
*****************/
int psp2chInputDialog(const unsigned char *text1, char *text2, const char *pretext)
{
	const char *menuStr = "   : ́@@@~ : ߂@@@ : @@@ : œ́@@@ : ";
    int ret = 0, fsize = 0, count = 0, i = 0, change = 1, index;
    SceUID fd;
    char file[FILE_PATH];
	strInpHis	**inphis;

	if (s2ch.cfg.inputType == 1){
		return psp2chLInput(text1, pretext, 1);					// OSKŃC
	} else if (s2ch.cfg.inputType == 2){
		return psp2chLInput(text1, pretext, 0);					// Simple IMEŃC
	}

    // add searchHistory.datJ
    sprintf(file, "%s/%s", s2ch.cwDir, searchWords);
	inphis = InputHisLoad( file );
    keyWords[0] = '\0';
    if(pretext != NULL)
    {
    	strncpy(keyWords, pretext, sizeof(keyWords)-1);
    }
    pgCreateTexture();
	pgPrintMenuBar(menuStr);
    s2ch.oldPad = s2ch.pad;
	index = -1;
    while (s2ch.running)
    {
    	if (change)
        {
        	change = 0;
        	pgFillvram(12, 0, 0, SCR_WIDTH, SCR_HEIGHT, 2);
			pgSetDrawStart(140, 70, 0, 0);
			pgPrint((char*)text1, YELLOW, 0, SCR_WIDTH);
			pgEditBox(WHITE, 140, 85, 340, 101);
			pgSetDrawStart(142, 87, 0, 0);
			pgPrint(keyWords, BLACK, WHITE, 340);
		}
        if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
        {
            if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
            {
                s2ch.oldPad = s2ch.pad;
                if(s2ch.pad.Buttons & PSP_CTRL_CIRCLE)
                {
                    psp2chGets(text2, keyWords, 128, 1);
					if (strlen(keyWords)==0){
						if (pretext){
							strncpy(keyWords, pretext, sizeof(keyWords)-1);
						}
					}
                    i = -1;
                }
                // add 
				else if(s2ch.pad.Buttons & PSP_CTRL_UP)			// i͗j
				{
					if (index>-1) index--;
					index = InputHisGet( keyWords, 128, inphis, index );
					if (index<0){
						keyWords[0] = '\0';
					}
				}
				else if(s2ch.pad.Buttons & PSP_CTRL_DOWN)		// i͗j
				{
					index++;
					index = InputHisGet( keyWords, 128, inphis, index );
				}
                else if(s2ch.pad.Buttons & PSP_CTRL_CROSS)
                {
                	ret = -1;
                    break;
                }
                else if(s2ch.pad.Buttons & PSP_CTRL_SQUARE)
                {
					InputHisAdd( inphis, keyWords );
					InputHisSave( file, inphis );
                    break;
                }
                else if(s2ch.pad.Buttons & PSP_CTRL_TRIANGLE)
				{
					psp2chInputKana(keyWords, 128);				// œ̓pbg
					pgPrintMenuBar(menuStr);					// L[KC_Xɖ߂
				}
                change = 1;
            }
        }
		pgDrawTexture(-1);
		pgCopyMenuBar();
		flipScreen(0);
    }
    pgDeleteTexture();
	InputHisFree( inphis );
    return ret;
}

int psp2chFileRead(SceUID fd, void *data, SceSize size)
{
	SceInt64 ret;
	
	ret = sceIoRead(fd, data, size);
	return ret;
}

int psp2chFileWrite(SceUID fd, const void *data, SceSize size)
{
	SceInt64 ret;
	
	ret = sceIoWrite(fd, data, size);
	if (ret != size)
		psp2chErrorDialog(0, "file write failed");
	return ret;
}

int psp2chReadPad(SceCtrlData *pad)
{
	static SceCtrlData old;
	
	sceCtrlPeekBufferPositive(pad, 1);
	if (old.Buttons != pad->Buttons) {
		old = *pad;
		return 1;
	}
	pad->Buttons = 0;
	return 0;
}


int psp2chInputKana(char* buf, unsigned int max)
{
	const char kana_table[] = 
	{
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', ' ', '', ' ', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', '',
		'', '', '', '', ''
	};
    const char* menuStr = "   :       ~ : ߂       :        : s";
    char inputBar[(5 + 1)* sizeof(char)];
    char *str;
    int change = 1, select = 0;
    unsigned int size;
    
    size = strlen(buf);
    pgPrintMenuBar((char*)menuStr);
    while (s2ch.running)
    {
		if (change)
		{
			change = 0;
			pgSetDrawStart(10, 90, 0, 0);
			pgEditBox(BOX_TEXT_BG_COLOR, 8, 88, 470, 250);
			str = buf;
			while ((str = pgPrint(str, BLACK, BOX_TEXT_BG_COLOR, 470)))
			{
				pgSetDrawStart(10, -1, 0, LINE_PITCH);
				if (winParam->pgCursorY >= 250)
				{
					break;
				}
			}
			pgSetDrawStart(200, 160, 0, 0);
			memcpy(inputBar, &kana_table[select], 5);
			inputBar[5] = '\0';
			pgFillvram(BLACK, 200, 160, 40, LINE_PITCH, 2);
			pgPrint(inputBar, WHITE, BOX_BG_COLOR, 400);
		}
        if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
        {
        	if(s2ch.pad.Buttons != s2ch.oldPad.Buttons)
        	{
        		s2ch.oldPad = s2ch.pad;
        		switch(s2ch.pad.Buttons)
        		{
        			case PSP_CTRL_UP:
        				select -= 5;
        				break;
        			case PSP_CTRL_DOWN:
        				select += 5;
        				break;
        			case PSP_CTRL_LEFT:
        				select--;
        				break;
        			case PSP_CTRL_RIGHT:
        				select++;
        				break;
        			case PSP_CTRL_CIRCLE:
        				if (size < max)
        				{
        					*(buf + size) = kana_table[select];
        					size++;
        				}
        				break;
        			case PSP_CTRL_SQUARE:
        				if (size > 0)
        				{
        					size--;
        				}
        				break;
        			case PSP_CTRL_TRIANGLE:
        				if (size < max)
        				{
        					*(buf + size) = '\n';
        					size++;
        				}
        				break;
        			case PSP_CTRL_CROSS:
        				return 0;
        		}
        		if (select < 0)
        		{
        			select += sizeof(kana_table);
        		}
        		else if ((int)sizeof(kana_table) <= select)
        		{
        			select -= sizeof(kana_table);
        		}
        		*(buf + size) = '\0';
	            change = 1;
	        }
        }
        pgCopyWindow(0, 8, 88, 470 - 8, 250 - 88);
		pgCopyMenuBar();
		flipScreen(0);
    }
    return 0;
}

