/*
* $Id$
*/

#include "psp2ch.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pg.h"
	
#include "colorMap.h"

extern S_2CH s2ch; // psp2ch.c
extern const char* colorFile; // psp2chMenu.c

#define setHex(A, B, C) \
    p = strstr(buf, (A));\
    if (p) {\
        p = strstr(p, "0x");\
        if(p){\
            p+=2;\
            (B) = strtol(p, NULL, 16);\
        }\
        else{(B) = (C);}\
    }\
    else{(B) = (C);}

#define setInt(A, B, C) \
    p = strstr(buf, (A));\
    if (p) {\
        p = strchr(p, '=');\
        if(p){\
            p++;\
            (B) = strtol(p, NULL, 10);\
        }\
        else{(B) = (C);}\
    }\
    else{(B) = (C);}

#define setString(A, B, C, D) \
    p = strstr(buf2, (A));\
    if (p) {\
        p = strchr(p, '"');\
        if(p){\
            p++;\
            for (i = 0; *p != '"'; i++) {\
                if (i >= (D)) break;\
                (B)[i] = *p++;\
            }\
            (B)[i] = '\0';\
        }\
        else{strcpy((B), (C));}\
    }\
    else{strcpy((B), (C));}\

/***********************************
config.iniǂݍ
************************************/
void psp2chIniLoadConfig(void)
{
    SceUID fd;
    SceIoStat st;
    char path[FILE_PATH];
    char *buf, *buf2;
    char *p;
    int i, j;

    sprintf(path, "%s/config.ini", s2ch.cwDir);
    i = sceIoGetstat(path, &st);
    if (i >= 0)
    {
        buf = (char*)malloc(st.st_size + 1);
        if (buf)
        {
            fd = sceIoOpen(path, PSP_O_RDONLY, FILE_PARMISSION);
            if (fd >= 0)
            {
                psp2chFileRead(fd, buf, st.st_size);
                sceIoClose(fd);
                buf[st.st_size] = '\0';
                buf2 = buf;
                setInt("CFG_PAD_REVERSE", s2ch.cfg.padReverse, 1);
                setInt("CFG_PAD_ACCEL", s2ch.cfg.padAccel, 1);
                setInt("CFG_PAD_CUTOFF", s2ch.cfg.padCutoff, 35);
				setInt("CFG_FILE_SORT", s2ch.cfg.fileSort, 1);		// t@C[Ńt@C\[g邩
				setInt("CFG_HBL", s2ch.cfg.hbl, 0);					// HBLœ
				setInt("CFG_INPUT_TYPE", s2ch.cfg.inputType, 0);	// ̓_CAO̎
				setInt("CFG_PAGEKEY_SWAP", s2ch.cfg.keySwap, 0);	// 摜L[ւ
                setString("CFG_IMAGE_DIR", s2ch.cfg.imageDir, "ms0:/PICTURE", FILE_PATH);
                s2ch.font.count = 1;
                strcpy(s2ch.font.fileA, "monafontA.bin");
                strcpy(s2ch.font.fileJ, "monafontJ.bin");
                s2ch.font.height = 12;
                s2ch.font.pitch = 13;
                s2ch.font.count = 1;
                free(buf);
                return;
            }
            else
            {
                free(buf);
            }
        }
    }
    s2ch.cfg.padReverse = 1;		// pbḧړ(1:Ώۂړ,-1:_ړ)
    s2ch.cfg.padAccel = 1;			// 0:2iK, 1:8iK
    s2ch.cfg.padCutoff = 35;		// AiOpbh̃j[gђl
	s2ch.cfg.fileSort = 1;			// t@C[Ńt@C\[g邩
	s2ch.cfg.hbl = 0;				// HBLœ
	s2ch.cfg.inputType = 0;			// ̓_CAO̎
	s2ch.cfg.keySwap = 0;			// 摜L[ւ
    strcpy(s2ch.cfg.imageDir, "ms0:/PICTURE");					// PICTUREtH_ɍ쐬tH_
    strcpy(s2ch.font.fileA, "monafontA.bin");					// VOoCg(ASCII, pJi)tHg
    strcpy(s2ch.font.fileJ, "monafontJ.bin");					// }`oCgtHg
    s2ch.font.height = 12;
    s2ch.font.pitch = 13;
    s2ch.font.count = 1;
    s2ch.font.set = NULL;
}

/***********************************
OJ[Zbg
ݒt@CǂݍŊeJ[Zbg
************************************/
void psp2chIniSetColor(const char* file)
{
    SceUID fd;
    SceIoStat st;
    char path[FILE_PATH];
    char *buf;
    char *p;
    int ret;

	// colorPaletteƂ̑Ή
    // X{
    s2ch.resHeaderColor.num = 16;
    s2ch.resHeaderColor.num2 = 29;
    s2ch.resHeaderColor.num3 = 30;
    s2ch.resHeaderColor.name1 = 17;
    s2ch.resHeaderColor.name2 = 18;
    s2ch.resHeaderColor.mail = 19;
    s2ch.resHeaderColor.date = 20;
    s2ch.resHeaderColor.id0 = 31;
    s2ch.resHeaderColor.id1 = 21;
    s2ch.resHeaderColor.id2 = 22;
    s2ch.resHeaderColor.id3 = 23;
    s2ch.resColor.text = 24;
    s2ch.resColor.bg = 25;
    s2ch.resColor.link = 26;
    s2ch.resBarColor.slider = 27;
    s2ch.resBarColor.bg = 28;
    // XAJ[@
    s2ch.resAHeaderColor.num = 32;
    s2ch.resAHeaderColor.num2 = 45;
    s2ch.resAHeaderColor.num3 = 46;
    s2ch.resAHeaderColor.name1 = 33;
    s2ch.resAHeaderColor.name2 = 34;
    s2ch.resAHeaderColor.mail = 35;
    s2ch.resAHeaderColor.date = 36;
    s2ch.resAHeaderColor.id0 = 47;
    s2ch.resAHeaderColor.id1 = 37;
    s2ch.resAHeaderColor.id2 = 38;
    s2ch.resAHeaderColor.id3 = 39;
    s2ch.resAColor.text = 40;
    s2ch.resAColor.bg = 41;
    s2ch.resAColor.link = 42;
    s2ch.resABarColor.slider = 43;
    s2ch.resABarColor.bg = 44;
    // j[o[@
    s2ch.menuColor.text = 48;
    s2ch.menuColor.bg = 49;
    s2ch.menuColor.bat1 = 50;
    s2ch.menuColor.bat2 = 51;
    s2ch.menuColor.bat3 = 52;
    // Xbhꗗ
    s2ch.threadColor.num[0] = 64;
    s2ch.threadColor.category[0] = 65;
    s2ch.threadColor.text1[0] = 66;
    s2ch.threadColor.text2[0] = 67;
    s2ch.threadColor.bg[0] = 68;
    s2ch.threadColor.count1[0] = 69;
    s2ch.threadColor.count2[0] = 70;
    s2ch.threadColor.num[1] = 71;
    s2ch.threadColor.category[1] = 72;
    s2ch.threadColor.text1[1] = 73;
    s2ch.threadColor.text2[1] = 74;
    s2ch.threadColor.bg[1] = 75;
    s2ch.threadColor.count1[1] = 76;
    s2ch.threadColor.count2[1] = 77;
    // JeS[
    s2ch.cateOnColor.cate.text = 80;
    s2ch.cateOnColor.cate.bg = 81;
    s2ch.cateOnColor.cate.s_text = 82;
    s2ch.cateOnColor.cate.s_bg = 83;
    s2ch.cateOnColor.ita.text = 84;
    s2ch.cateOnColor.ita.bg = 85;
    s2ch.cateOnColor.ita.s_text = 86;
    s2ch.cateOnColor.ita.s_bg = 87;
    s2ch.cateOnColor.base = 88;
    // ꗗ
    s2ch.cateOffColor.cate.text = 96;
    s2ch.cateOffColor.cate.bg = 97;
    s2ch.cateOffColor.cate.s_text = 98;
    s2ch.cateOffColor.cate.s_bg = 99;
    s2ch.cateOffColor.ita.text = 100;
    s2ch.cateOffColor.ita.bg = 101;
    s2ch.cateOffColor.ita.s_text = 102;
    s2ch.cateOffColor.ita.s_bg = 103;
    s2ch.cateOffColor.base = 104;
    // MtH[
    s2ch.formColor.ita = 112;
    s2ch.formColor.title = 113;
    s2ch.formColor.title_bg = 114;
    // j[EBhE
    s2ch.menuWinColor.text = 128;
    s2ch.menuWinColor.bg = 129;
    s2ch.menuWinColor.s_text = 130;
    s2ch.menuWinColor.s_bg = 131;
    s2ch.menuWinColor.dir = 132;
    // J[\
    s2ch.cursorColor.arrow1 = 144;
    s2ch.cursorColor.arrow2 = 145;

    if (file == NULL)
    {
        file = colorFile;
    }
    sprintf(path, "%s/%s/%s", s2ch.cwDir, COLOR_DIR, file);
    ret = sceIoGetstat(path, &st);
    if (ret >= 0)
    {
        buf = (char*)malloc(st.st_size + 1);
        if (buf)
        {
            fd = sceIoOpen(path, PSP_O_RDONLY, FILE_PARMISSION);
            if (fd >= 0)
            {
                psp2chFileRead(fd, buf, st.st_size);
                sceIoClose(fd);
                buf[st.st_size] = '\0';
                setHex("RES_NUMBER", colorPalette[16], 0xF00F);
                setHex("RES_NAME_HEAD", colorPalette[17], 0xF000);
                setHex("RES_NAME_BODY", colorPalette[18], 0xF0C0);
                setHex("RES_MAIL", colorPalette[19], 0xF999);
                setHex("RES_DATE", colorPalette[20], 0xF000);
                setHex("RES_ID_HEAD_1", colorPalette[21], 0xFF00);
                setHex("RES_ID_HEAD_2", colorPalette[22], 0xF00F);
                setHex("RES_ID_BODY", colorPalette[23], 0xFF00);
                setHex("RES_TEXT", colorPalette[24], 0xF000);
                setHex("RES_BG", colorPalette[25], 0xFEEE);
                setHex("RES_LINK", colorPalette[26], 0xFF00);
                setHex("RES_BAR_SLIDER", colorPalette[27], 0xF0FF);
                setHex("RES_BAR_BG", colorPalette[28], 0xFFFC);
                setHex("RES_NUMBER2", colorPalette[29], 0xFF00);
                setHex("RES_NUMBER3", colorPalette[30], 0xF808);
                setHex("RES_ID_HEAD_0", colorPalette[31], 0xF000);

                setHex("RES_A_NUMBER", colorPalette[32], 0xF00F);
                setHex("RES_A_NAME_HEAD", colorPalette[33], 0xF000);
                setHex("RES_A_NAME_BODY", colorPalette[34], 0xF0C0);
                setHex("RES_A_MAIL", colorPalette[35], 0xF999);
                setHex("RES_A_DATE", colorPalette[36], 0xF000);
                setHex("RES_A_ID_HEAD_1", colorPalette[37], 0xFF00);
                setHex("RES_A_ID_HEAD_2", colorPalette[38], 0xF00F);
                setHex("RES_A_ID_BODY", colorPalette[39], 0xFF00);
                setHex("RES_A_TEXT", colorPalette[40], 0xF000);
                setHex("RES_A_BG", colorPalette[41], 0xFCFF);
                setHex("RES_A_LINK", colorPalette[42], 0xFF00);
                setHex("RES_A_BAR_SLIDER", colorPalette[43], 0xFCF0);
                setHex("RES_A_BAR_BG", colorPalette[44], 0xFFFC);
                setHex("RES_A_NUMBER2", colorPalette[45], 0xFF00);
                setHex("RES_A_NUMBER3", colorPalette[46], 0xF808);
                setHex("RES_A_ID_HEAD_0", colorPalette[47], 0xF000);

                setHex("MENU_TEXT", colorPalette[48], 0xFFFF);
                setHex("MENU_BG", colorPalette[49], 0xF000);
                setHex("MENU_BATTERY_1", colorPalette[50], 0xF0F0);
                setHex("MENU_BATTERY_2", colorPalette[51], 0xF0FF);
                setHex("MENU_BATTERY_3", colorPalette[52], 0xF00F);

                setHex("THREAD_NUMBER", colorPalette[64], 0xF00F);
                setHex("THREAD_CATEGORY", colorPalette[65], 0xF00F);
                setHex("THREAD_TEXT_1", colorPalette[66], 0xFF00);
                setHex("THREAD_TEXT_2", colorPalette[67], 0xF00F);
                setHex("THREAD_BG", colorPalette[68], 0xFCFC);
                setHex("THREAD_COUNT_1", colorPalette[69], 0xF000);
                setHex("THREAD_COUNT_2", colorPalette[70], 0xF00F);
                setHex("THREAD_SELECT_NUMBER", colorPalette[71], 0xF00F);
                setHex("THREAD_SELECT_CATEGORY", colorPalette[72], 0xF009);
                setHex("THREAD_SELECT_TEXT_1", colorPalette[73], 0xF900);
                setHex("THREAD_SELECT_TEXT_2", colorPalette[74], 0xF009);
                setHex("THREAD_SELECT_BG", colorPalette[75], 0xFCCC);
                setHex("THREAD_SELECT_COUNT_1", colorPalette[76], 0xF000);
                setHex("THREAD_SELECT_COUNT_2", colorPalette[77], 0xF00F);

                setHex("CATE_ON_TEXT", colorPalette[80], 0xF03C);
                setHex("CATE_ON_BG", colorPalette[81], 0xFFFF);
                setHex("CATE_ON_S_TEXT", colorPalette[82], 0xFFFF);
                setHex("CATE_ON_S_BG", colorPalette[83], 0xF03C);
                setHex("ITA_OFF_TEXT", colorPalette[84], 0xFF66);
                setHex("ITA_OFF_BG", colorPalette[85], 0xFCCC);
                setHex("ITA_OFF_S_TEXT", colorPalette[86], 0xFCCC);
                setHex("ITA_OFF_S_BG", colorPalette[87], 0xFF66);
                setHex("CATE_ON_BASE", colorPalette[88], 0xFFFF);

                setHex("CATE_OFF_TEXT", colorPalette[96], 0xF698);
                setHex("CATE_OFF_BG", colorPalette[97], 0xFCCC);
                setHex("CATE_OFF_S_TEXT", colorPalette[98], 0xFCCC);
                setHex("CATE_OFF_S_BG", colorPalette[99], 0xF698);
                setHex("ITA_ON_TEXT", colorPalette[100], 0xFF00);
                setHex("ITA_ON_BG", colorPalette[101], 0xFFFF);
                setHex("ITA_ON_S_TEXT", colorPalette[102], 0xFFFF);
                setHex("ITA_ON_S_BG", colorPalette[103], 0xFF00);
                setHex("CATE_OFF_BASE", colorPalette[104], 0xFFFF);

                setHex("FORM_ITA_TEXT", colorPalette[112], 0xFCCC);
                setHex("FORM_TITLE_TEXT", colorPalette[113], 0xFFFF);
                setHex("FORM_TITLE_BG", colorPalette[114], 0xF00F);

                setHex("MENU_WIN_TEXT", colorPalette[128], 0xFCCC);
                setHex("MENU_WIN_BG", colorPalette[129], 0xF000);
                setHex("MENU_WIN_S_TEXT", colorPalette[130], 0xFFFF);
                setHex("MENU_WIN_S_BG", colorPalette[131], 0xFF00);
                setHex("MENU_WIN_DIR", colorPalette[132], 0xF0FF);

                setHex("CURSOR_ARROW1", colorPalette[144], 0xF000);
                setHex("CURSOR_ARROW2", colorPalette[145], 0xFFFF);
            }
            free(buf);
        }
    } else {
		colorPalette[48] = 0xFFFF;								// MENU_TEXT
		colorPalette[49] = 0x8000;								// MENU_BG
		colorPalette[50] = 0xF0F0;								// MENU_BATTERY_1
		colorPalette[51] = 0xF0FF;								// MENU_BATTERY_2
		colorPalette[52] = 0xF00F;								// MENU_BATTERY_3
		colorPalette[128] = 0xFCCC;								// MENU_WIN_TEXT
		colorPalette[129] = 0xF000;								// MENU_WIN_BG
		colorPalette[130] = 0xFFFF;								// MENU_WIN_S_TEXT
		colorPalette[131] = 0xFF00;								// MENU_WIN_S_BG
		colorPalette[132] = 0xF0FF;								// MENU_WIN_DIR
	}
    pgCLUTUpdate();
    return;
}

/********************
{^̊蓖
button.iniǂݍŃ{^̐ݒ
********************/
void psp2chIniSetButtons(void)
{
    SceUID fd;
    SceIoStat st;
    char path[FILE_PATH];
    char *buf;
    char *p;
    int ret;

    sprintf(path, "%s/button.ini", s2ch.cwDir);
    ret = sceIoGetstat(path, &st);
    if (ret >= 0)
    {
        buf = (char*)malloc(st.st_size + 1);
        if (buf)
        {
            fd = sceIoOpen(path, PSP_O_RDONLY, FILE_PARMISSION);
            if (fd >= 0)
            {
                psp2chFileRead(fd, buf, st.st_size);
                sceIoClose(fd);
                buf[st.st_size] = '\0';
                setInt("RES_FORM_H", s2ch.btnRes[0].form, 8192);
                setInt("RES_BACK_H", s2ch.btnRes[0].back, 16384);
                setInt("RES_RELOAD_H", s2ch.btnRes[0].reload, 4096);
                setInt("RES_DATDEL_H", s2ch.btnRes[0].datDel, 32768);
                setInt("RES_SHIFT_H", s2ch.btnRes[0].change, 512);
                setInt("RES_FORM_V", s2ch.btnRes[1].form, 8192);
                setInt("RES_BACK_V", s2ch.btnRes[1].back, 16384);
                setInt("RES_RELOAD_V", s2ch.btnRes[1].reload, 4096);
                setInt("RES_DATDEL_V", s2ch.btnRes[1].datDel, 32768);
                setInt("RES_SHIFT_V", s2ch.btnRes[1].change, 512);

                setInt("RES_TOP_H", s2ch.btnRes[0].s.top, 16);
                setInt("RES_END_H", s2ch.btnRes[0].s.end, 64);
                setInt("RES_ADDFAV_H", s2ch.btnRes[0].addFav, 8192);
                setInt("RES_DELFAV_H", s2ch.btnRes[0].delFav, 32768);
                setInt("RES_CURSOR_H", s2ch.btnRes[0].cursor, 4096);
                setInt("RES_WIDE_H", s2ch.btnRes[0].wide, 16384);
                setInt("RES_SEARCH_H", s2ch.btnRes[0].search, 256);
                setInt("RES_TOP_V", s2ch.btnRes[1].s.top, 32);
                setInt("RES_END_V", s2ch.btnRes[1].s.end, 128);
                setInt("RES_ADDFAV_V", s2ch.btnRes[1].addFav, 8192);
                setInt("RES_DELFAV_V", s2ch.btnRes[1].delFav, 32768);
                setInt("RES_CURSOR_V", s2ch.btnRes[1].cursor, 4096);
                setInt("RES_WIDE_V", s2ch.btnRes[1].wide, 16384);
                setInt("RES_SEARCH_V", s2ch.btnRes[1].search, 256);

                setInt("RES_NUMRES_H", s2ch.btnRes[0].resForm, 8192);
                setInt("RES_NUMBACK_H", s2ch.btnRes[0].resFBack, 16384);
                setInt("RES_NUMRES_V", s2ch.btnRes[1].resForm, 8192);
                setInt("RES_NUMBACK_V", s2ch.btnRes[1].resFBack, 16384);

                setInt("RES_IDVIEW_H", s2ch.btnRes[0].idView, 8192);
                setInt("RES_IDNG_H", s2ch.btnRes[0].idNG, 32768);
                setInt("RES_IDBACK_H", s2ch.btnRes[0].idBack, 16384);
                setInt("RES_IDVIEW_V", s2ch.btnRes[1].idView, 8192);
                setInt("RES_IDNG_V", s2ch.btnRes[1].idNG, 32768);
                setInt("RES_IDBACK_V", s2ch.btnRes[1].idBack, 16384);

                setInt("RES_RESVIEW_H", s2ch.btnRes[0].resView, 8192);
                setInt("RES_RESMOVE_H", s2ch.btnRes[0].resMove, 4096);
                setInt("RES_RESBACK_H", s2ch.btnRes[0].resBack, 16384);
                setInt("RES_RESVIEW_V", s2ch.btnRes[1].resView, 8192);
                setInt("RES_RESMOVE_V", s2ch.btnRes[1].resMove, 4096);
                setInt("RES_RESBACK_V", s2ch.btnRes[1].resBack, 16384);

                setInt("RES_URL_H", s2ch.btnRes[0].url, 8192);
                setInt("RES_URL_HTML_H", s2ch.btnRes[0].urlHtml, 32768);
                setInt("RES_URLBACK_H", s2ch.btnRes[0].urlBack, 16384);
                setInt("RES_URLDOWN_H", s2ch.btnRes[0].urlDown, 4096);
                setInt("RES_URL_V", s2ch.btnRes[1].url, 8192);
                setInt("RES_URL_HTML_V", s2ch.btnRes[1].urlHtml, 32768);
                setInt("RES_URLBACK_V", s2ch.btnRes[1].urlBack, 16384);
                setInt("RES_URLDOWN_V", s2ch.btnRes[1].urlDown, 4096);

                setInt("RES_UP_H", s2ch.btnRes[0].s.up, 16);
                setInt("RES_PAGEUP_H", s2ch.btnRes[0].s.pUp, 128);
                setInt("RES_DOWN_H", s2ch.btnRes[0].s.down, 64);
                setInt("RES_PAGEDOWN_H", s2ch.btnRes[0].s.pDown, 32);
                setInt("RES_UP_V", s2ch.btnRes[1].s.up, 32);
                setInt("RES_PAGEUP_V", s2ch.btnRes[1].s.pUp, 16);
                setInt("RES_DOWN_V", s2ch.btnRes[1].s.down, 128);
                setInt("RES_PAGEDOWN_V", s2ch.btnRes[1].s.pDown, 64);

                setInt("SCROLL_UP_H", s2ch.listB[0].up, 16);
                setInt("PAGE_UP_H", s2ch.listB[0].pUp, 128);
                setInt("SCROLL_DOWN_H", s2ch.listB[0].down, 64);
                setInt("PAGE_DOWN_H", s2ch.listB[0].pDown, 32);
                setInt("LIST_TOP_H", s2ch.listB[0].top, 16);
                setInt("LIST_END_H", s2ch.listB[0].end, 64);
                setInt("SCROLL_UP_V", s2ch.listB[1].up, 32);
                setInt("PAGE_UP_V", s2ch.listB[1].pUp, 16);
                setInt("SCROLL_DOWN_V", s2ch.listB[1].down, 128);
                setInt("PAGE_DOWN_V", s2ch.listB[1].pDown, 64);
                setInt("LIST_TOP_V", s2ch.listB[1].top, 32);
                setInt("LIST_END_V", s2ch.listB[1].end, 128);

                setInt("ITA_OK_H", s2ch.itaB[0].ok, 8192);
                setInt("ITA_ESC_H", s2ch.itaB[0].esc, 16384);
                setInt("ITA_MOVEFAV_H", s2ch.itaB[0].move, 32768);
                setInt("ITA_RELOAD_H", s2ch.itaB[0].reload, 4096);
                setInt("ITA_SHIFT_H", s2ch.itaB[0].shift, 512);
                setInt("ITA_OK_V", s2ch.itaB[1].ok, 256);
                setInt("ITA_ESC_V", s2ch.itaB[1].esc, 16384);
                setInt("ITA_MOVEFAV_V", s2ch.itaB[1].move, 32768);
                setInt("ITA_RELOAD_V", s2ch.itaB[1].reload, 4096);
                setInt("ITA_SHIFT_V", s2ch.itaB[1].shift, 512);

                setInt("ITA_ADDFAV_H", s2ch.itaB[0].addFav, 4096);
                setInt("ITA_2CHSEARCH_H", s2ch.itaB[0].search2ch, 32768);
                setInt("ITA_ADDFAV_V", s2ch.itaB[1].addFav, 4096);
                setInt("ITA_2CHSEARCH_V", s2ch.itaB[1].search2ch, 32768);

                setInt("THREAD_OK_H", s2ch.thB[0].ok, 8192);
                setInt("THREAD_ESC_H", s2ch.thB[0].esc, 16384);
                setInt("THREAD_MOVEFAV_H", s2ch.thB[0].move, 32768);
                setInt("THREAD_RELOAD_H", s2ch.thB[0].reload, 4096);
                setInt("THREAD_SHIFT_H", s2ch.thB[0].shift, 512);
                setInt("THREAD_OK_V", s2ch.thB[1].ok, 256);
                setInt("THREAD_ESC_V", s2ch.thB[1].esc, 16384);
                setInt("THREAD_MOVEFAV_V", s2ch.thB[1].move, 32768);
                setInt("THREAD_RELOAD_V", s2ch.thB[1].reload, 4096);
                setInt("THREAD_SHIFT_V", s2ch.thB[1].shift, 512);

                setInt("THREAD_SORT_H", s2ch.thB[0].sort, 8192);
                setInt("THREAD_SEARCH_H", s2ch.thB[0].search, 4096);
                setInt("THREAD_2CHSEARCH_H", s2ch.thB[0].search2ch, 32768);
                setInt("THREAD_SORT_V", s2ch.thB[1].sort, 8192);
                setInt("THREAD_SEARCH_V", s2ch.thB[1].search, 4096);
                setInt("THREAD_2CHSEARCH_V", s2ch.thB[1].search2ch, 32768);

                setInt("FAV_OK_H", s2ch.favB[0].ok, 8192);
                setInt("FAV_MOVEITS_H", s2ch.favB[0].move, 16384);
                setInt("FAV_CHANGE_H", s2ch.favB[0].change, 4096);
                setInt("FAV_DEL_H", s2ch.favB[0].del, 32768);
                setInt("FAV_SHIFT_H", s2ch.favB[0].shift, 512);
                setInt("FAV_OK_V", s2ch.favB[1].ok, 256);
                setInt("FAV_MOVEITS_V", s2ch.favB[1].move, 16384);
                setInt("FAV_CHANGE_V", s2ch.favB[1].change, 4096);
                setInt("FAV_DEL_V", s2ch.favB[1].del, 32768);
                setInt("FAV_SHIFT_V", s2ch.favB[1].shift, 512);

                setInt("FAV_SORT_H", s2ch.favB[0].sort, 8192);
                setInt("FAV_2CHSEARCH_H", s2ch.favB[0].search2ch, 32768);
                setInt("FAV_UPDATE_H", s2ch.favB[0].update, 4096);
                setInt("FAV_TRANS_H", s2ch.favB[0].trans, 256);
                setInt("FAV_SORT_V", s2ch.favB[1].sort, 8192);
                setInt("FAV_2CHSEARCH_V", s2ch.favB[1].search2ch, 32768);
                setInt("FAV_UPDATE_V", s2ch.favB[1].update, 4096);
                setInt("FAV_TRANS_V", s2ch.favB[1].trans, 8192);

                setInt("SEARCH_OK_H", s2ch.findB[0].ok, 8192);
                setInt("SEARCH_ESC_H", s2ch.findB[0].esc, 16384);
                setInt("SEARCH_ITA_H", s2ch.findB[0].ita, 32768);
                setInt("SEARCH_FAV_H", s2ch.findB[0].fav, 4096);
                setInt("SEARCH_SHIFT_H", s2ch.findB[0].shift, 512);
                setInt("SEARCH_OK_V", s2ch.findB[1].ok, 256);
                setInt("SEARCH_ESC_V", s2ch.findB[1].esc, 16384);
                setInt("SEARCH_ITA_V", s2ch.findB[1].ita, 32768);
                setInt("SEARCH_FAV_V", s2ch.findB[1].fav, 4096);
                setInt("SEARCH_SHIFT_V", s2ch.findB[1].shift, 512);

                setInt("SEARCH_2CHSEARCH_H", s2ch.findB[0].search2ch, 32768);
                setInt("SEARCH_2CHSEARCH_V", s2ch.findB[1].search2ch, 32768);

                setInt("MENUWIN_OK_H", s2ch.menuWin[0].ok, 8192);
                setInt("MENUWIN_ESC_H", s2ch.menuWin[0].esc, 16384);
                setInt("MENUWIN_OK_V", s2ch.menuWin[1].ok, 256);
                setInt("MENUWIN_ESC_V", s2ch.menuWin[1].esc, 16384);

                setInt("MENUNG_DEL_H", s2ch.menuNG[0].del, 8192);
                setInt("MENUNG_ESC_H", s2ch.menuNG[0].esc, 16384);
                setInt("MENUNG_DEL_V", s2ch.menuNG[1].del, 256);
                setInt("MENUNG_ESC_V", s2ch.menuNG[1].esc, 16384);

                free(buf);
                return;
            }
            else
            {
                free(buf);
            }
        }
    }
    s2ch.btnRes[0].form	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[0].back	= PSP_CTRL_CROSS;
    s2ch.btnRes[0].reload	= PSP_CTRL_TRIANGLE;
    s2ch.btnRes[0].datDel	= PSP_CTRL_SQUARE;
    s2ch.btnRes[0].change	= PSP_CTRL_RTRIGGER;

    s2ch.btnRes[0].s.top	= PSP_CTRL_UP;
    s2ch.btnRes[0].s.end	= PSP_CTRL_DOWN;
    s2ch.btnRes[0].addFav	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[0].delFav	= PSP_CTRL_SQUARE;
    s2ch.btnRes[0].cursor	= PSP_CTRL_TRIANGLE;
    s2ch.btnRes[0].wide	= PSP_CTRL_CROSS;
    s2ch.btnRes[0].search	= PSP_CTRL_LTRIGGER;

    s2ch.btnRes[0].resForm	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[0].resFBack	= PSP_CTRL_CROSS;

    s2ch.btnRes[0].idView	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[0].idNG	= PSP_CTRL_SQUARE;
    s2ch.btnRes[0].idBack	= PSP_CTRL_CROSS;

    s2ch.btnRes[0].resView	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[0].resMove	= PSP_CTRL_TRIANGLE;
    s2ch.btnRes[0].resBack	= PSP_CTRL_CROSS;

    s2ch.btnRes[0].url		= PSP_CTRL_CIRCLE;
    s2ch.btnRes[0].urlHtml	= PSP_CTRL_SQUARE;
    s2ch.btnRes[0].urlBack	= PSP_CTRL_CROSS;
    s2ch.btnRes[0].urlDown	= PSP_CTRL_TRIANGLE;

    s2ch.btnRes[0].s.up		= PSP_CTRL_UP;
    s2ch.btnRes[0].s.pUp		= PSP_CTRL_LEFT;
    s2ch.btnRes[0].s.down		= PSP_CTRL_DOWN;
    s2ch.btnRes[0].s.pDown	= PSP_CTRL_RIGHT;

    s2ch.btnRes[1].form	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[1].back	= PSP_CTRL_CROSS;
    s2ch.btnRes[1].reload	= PSP_CTRL_TRIANGLE;
    s2ch.btnRes[1].datDel	= PSP_CTRL_SQUARE;
    s2ch.btnRes[1].change	= PSP_CTRL_RTRIGGER;

    s2ch.btnRes[1].s.top	= PSP_CTRL_RIGHT;
    s2ch.btnRes[1].s.end	= PSP_CTRL_LEFT;
    s2ch.btnRes[1].addFav	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[1].delFav	= PSP_CTRL_SQUARE;
    s2ch.btnRes[1].cursor	= PSP_CTRL_TRIANGLE;
    s2ch.btnRes[1].wide	= PSP_CTRL_CROSS;
    s2ch.btnRes[1].search	= PSP_CTRL_LTRIGGER;

    s2ch.btnRes[1].resForm	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[1].resFBack	= PSP_CTRL_CROSS;

    s2ch.btnRes[1].idView	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[1].idNG	= PSP_CTRL_SQUARE;
    s2ch.btnRes[1].idBack	= PSP_CTRL_CROSS;

    s2ch.btnRes[1].resView	= PSP_CTRL_CIRCLE;
    s2ch.btnRes[1].resMove	= PSP_CTRL_TRIANGLE;
    s2ch.btnRes[1].resBack	= PSP_CTRL_CROSS;

    s2ch.btnRes[1].url		= PSP_CTRL_CIRCLE;
    s2ch.btnRes[1].urlHtml	= PSP_CTRL_SQUARE;
    s2ch.btnRes[1].urlBack	= PSP_CTRL_CROSS;
    s2ch.btnRes[1].urlDown	= PSP_CTRL_TRIANGLE;

    s2ch.btnRes[1].s.up		= PSP_CTRL_RIGHT;
    s2ch.btnRes[1].s.pUp		= PSP_CTRL_UP;
    s2ch.btnRes[1].s.down		= PSP_CTRL_LEFT;
    s2ch.btnRes[1].s.pDown	= PSP_CTRL_DOWN;

    s2ch.listB[0].up		= PSP_CTRL_UP;
    s2ch.listB[0].pUp		= PSP_CTRL_LEFT;
    s2ch.listB[0].down		= PSP_CTRL_DOWN;
    s2ch.listB[0].pDown	= PSP_CTRL_RIGHT;
    s2ch.listB[0].top		= PSP_CTRL_UP;
    s2ch.listB[0].end		= PSP_CTRL_DOWN;
    s2ch.listB[1].up		= PSP_CTRL_RIGHT;
    s2ch.listB[1].pUp		= PSP_CTRL_UP;
    s2ch.listB[1].down		= PSP_CTRL_LEFT;
    s2ch.listB[1].pDown		= PSP_CTRL_DOWN;
    s2ch.listB[1].top		= PSP_CTRL_RIGHT;
    s2ch.listB[1].end		= PSP_CTRL_LEFT;

    s2ch.itaB[0].ok     = PSP_CTRL_CIRCLE;
    s2ch.itaB[0].esc    = PSP_CTRL_CROSS;
    s2ch.itaB[0].move   = PSP_CTRL_SQUARE;
    s2ch.itaB[0].reload = PSP_CTRL_TRIANGLE;
    s2ch.itaB[0].shift  = PSP_CTRL_RTRIGGER;
    s2ch.itaB[1].ok     = PSP_CTRL_LTRIGGER;
    s2ch.itaB[1].esc    = PSP_CTRL_CROSS;
    s2ch.itaB[1].move   = PSP_CTRL_SQUARE;
    s2ch.itaB[1].reload = PSP_CTRL_TRIANGLE;
    s2ch.itaB[1].shift  = PSP_CTRL_RTRIGGER;

    s2ch.itaB[0].addFav    = PSP_CTRL_TRIANGLE;
    s2ch.itaB[0].search2ch = PSP_CTRL_SQUARE;
    s2ch.itaB[1].addFav    = PSP_CTRL_TRIANGLE;
    s2ch.itaB[1].search2ch = PSP_CTRL_SQUARE;

    s2ch.thB[0].ok		= PSP_CTRL_CIRCLE;
    s2ch.thB[0].esc	= PSP_CTRL_CROSS;
    s2ch.thB[0].move	= PSP_CTRL_SQUARE;
    s2ch.thB[0].reload	= PSP_CTRL_TRIANGLE;
    s2ch.thB[0].shift	= PSP_CTRL_RTRIGGER;
    s2ch.thB[1].ok		= PSP_CTRL_LTRIGGER;
    s2ch.thB[1].esc	= PSP_CTRL_CROSS;
    s2ch.thB[1].move	= PSP_CTRL_SQUARE;
    s2ch.thB[1].reload	= PSP_CTRL_TRIANGLE;
    s2ch.thB[1].shift	= PSP_CTRL_RTRIGGER;

    s2ch.thB[0].sort = PSP_CTRL_CIRCLE;
    s2ch.thB[0].search = PSP_CTRL_TRIANGLE;
    s2ch.thB[0].search2ch = PSP_CTRL_SQUARE;
    s2ch.thB[1].sort = PSP_CTRL_CIRCLE;
    s2ch.thB[1].search = PSP_CTRL_TRIANGLE;
    s2ch.thB[1].search2ch = PSP_CTRL_SQUARE;

    s2ch.favB[0].ok     = PSP_CTRL_CIRCLE;
    s2ch.favB[0].move   = PSP_CTRL_CROSS;
    s2ch.favB[0].change = PSP_CTRL_TRIANGLE;
    s2ch.favB[0].del    = PSP_CTRL_SQUARE;
    s2ch.favB[0].shift  = PSP_CTRL_RTRIGGER;
    s2ch.favB[1].ok     = PSP_CTRL_LTRIGGER;
    s2ch.favB[1].move   = PSP_CTRL_CROSS;
    s2ch.favB[1].change = PSP_CTRL_TRIANGLE;
    s2ch.favB[1].del    = PSP_CTRL_SQUARE;
    s2ch.favB[1].shift  = PSP_CTRL_RTRIGGER;

    s2ch.favB[0].sort      = PSP_CTRL_CIRCLE;
    s2ch.favB[0].search2ch = PSP_CTRL_SQUARE;
    s2ch.favB[0].update    = PSP_CTRL_TRIANGLE;
    s2ch.favB[0].trans     = PSP_CTRL_LTRIGGER;
    s2ch.favB[1].sort      = PSP_CTRL_CIRCLE;
    s2ch.favB[1].search2ch = PSP_CTRL_SQUARE;
    s2ch.favB[1].update    = PSP_CTRL_TRIANGLE;
    s2ch.favB[1].trans     = PSP_CTRL_CIRCLE;

    s2ch.findB[0].ok = PSP_CTRL_CIRCLE;
    s2ch.findB[0].esc = PSP_CTRL_CROSS;
    s2ch.findB[0].ita = PSP_CTRL_SQUARE;
    s2ch.findB[0].fav = PSP_CTRL_TRIANGLE;
    s2ch.findB[0].shift = PSP_CTRL_RTRIGGER;
    s2ch.findB[1].ok = PSP_CTRL_CIRCLE;
    s2ch.findB[1].esc = PSP_CTRL_CROSS;
    s2ch.findB[1].ita = PSP_CTRL_SQUARE;
    s2ch.findB[1].fav = PSP_CTRL_TRIANGLE;
    s2ch.findB[1].shift = PSP_CTRL_RTRIGGER;

    s2ch.findB[0].search2ch = PSP_CTRL_SQUARE;
    s2ch.findB[1].search2ch = PSP_CTRL_SQUARE;

    s2ch.menuWin[0].ok = PSP_CTRL_CIRCLE;
    s2ch.menuWin[0].esc = PSP_CTRL_CROSS;
    s2ch.menuWin[1].ok = PSP_CTRL_RTRIGGER;
    s2ch.menuWin[1].esc = PSP_CTRL_CROSS;

    s2ch.menuNG[0].del = PSP_CTRL_CIRCLE;
    s2ch.menuNG[0].esc = PSP_CTRL_CROSS;
    s2ch.menuNG[1].del = PSP_CTRL_RTRIGGER;
    s2ch.menuNG[1].esc = PSP_CTRL_CROSS;
}
