/*
* $Id: psp2chMenu.c 148 2008-08-27 06:31:27Z bird_may_nike $
*
* 2010-05-31 STEAR BGMt@C[֘AC
*/

#include "psp2ch.h"
#include <psputility.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "pg.h"
#include "psp2chIni.h"
#include "psp2chMenu.h"
#include "psp2chImageView.h"
#include "psp2chAudio.h"
#include "charConv.h"
#include "utf8.h"
#include "SMEMO/draw.h"

extern S_2CH s2ch; // psp2ch.c
extern char keyWords[128]; //psp2ch.c
extern Window_Layer *winParam;

const char* colorFile = "color.ini";

// display
int dispPalette = 0;
char palette[512] = "";

int gNGchange;													// NG[hɕω

// prototype
static void psp2chDrawMenu(char** menuList, S_2CH_SCREEN menu, int x, int y, int width, int height);
static int psp2chMenuFileCtrl(char* path, char* name, int status);

int	SMEMOfile(char *path);										// PSP

/*********************
j[̍쐬
**********************/
#define getIndex(X, Y) \
    tmp = (X);\
    (Y) = 0;\
    for (i = 0; i < 16; i++)\
    {\
        if (tmp & 1)\
        {\
            break;\
        }\
        (Y)++;\
        tmp >>= 1;\
    }

void psp2chMenuSetMenuString(const char **sBtnH, const char **sBtnV)
{
    int index1, index2;
    int i, tmp;

    getIndex(s2ch.menuWin[0].ok, index1);
    getIndex(s2ch.menuWin[0].esc, index2);
    sprintf(s2ch.menuWin[0].main, "@%s : @@@@@%s : ߂",
            sBtnH[index1], sBtnH[index2]);

    getIndex(s2ch.menuWin[1].ok, index1);
    getIndex(s2ch.menuWin[1].esc, index2);
    sprintf(s2ch.menuWin[1].main, "@%s : @@@@@%s : ߂",
            sBtnV[index1], sBtnV[index2]);

    getIndex(s2ch.menuNG[0].del, index1);
    getIndex(s2ch.menuNG[0].esc, index2);
    sprintf(s2ch.menuNG[0].main, "@%s : 폜@@@@%s : ߂",
            sBtnH[index1], sBtnH[index2]);

    getIndex(s2ch.menuNG[1].del, index1);
    getIndex(s2ch.menuNG[1].esc, index2);
    sprintf(s2ch.menuNG[1].main, "@%s : 폜@@@@%s : ߂",
            sBtnV[index1], sBtnV[index2]);
}

/****************
j[EBhE`
****************/
static void psp2chDrawMenu(char** menuList, S_2CH_SCREEN menu, int x, int y, int width, int height)
{
    int i, start, lineEnd;
	
    pgSetDrawStart(x, y, 0, 0);
    lineEnd = height / LINE_PITCH;
    start = menu.start;
    if (start + lineEnd > menu.count)
    {
        start = menu.count - lineEnd;
    }
    if (start < 0)
    {
        start = 0;
    }
    pgFillvram(0, 0, 0, BUF_WIDTH, BUF_HEIGHT, 2);
    pgFillvram(s2ch.menuWinColor.bg, x, y, width, height, 2);
    for (i = start; i < start + lineEnd; i++)
    {
        if (i >= menu.count)
        {
            return;
        }
        if (i == menu.select)
        {
            pgFillvram(s2ch.menuWinColor.s_bg, x, winParam->pgCursorY, width, LINE_PITCH, 2);
            pgPrint(menuList[i], s2ch.menuWinColor.s_text, s2ch.menuWinColor.s_bg, x + width);
        }
        else
        {
            pgPrint(menuList[i], s2ch.menuWinColor.text, s2ch.menuWinColor.bg, x + width);
        }
        pgSetDrawStart(x, -1, 0, LINE_PITCH);
    }
}

/****************
t@CXgEBhE`
****************/
static void psp2chDrawMenu2(char** menuList, int* menuCor, S_2CH_SCREEN menu, int x, int y, int width, int height)
{
	char	strbuf[256];
	int		i, start, lineEnd;

	pgSetDrawStart(x, y, 0, 0);
	lineEnd = height / LINE_PITCH;
	start = menu.start;
	if (start + lineEnd > menu.count){
		start = menu.count - lineEnd;
	}
	if (start < 0){
		start = 0;
	}
	pgFillvram(0, 0, 0, BUF_WIDTH, BUF_HEIGHT, 2);
	pgFillvram(s2ch.menuWinColor.bg, x, y, width, height, 2);
	for (i = start; i < start + lineEnd; i++){
		if (i >= menu.count){
			return;
		}
		if (s2ch.cfg.hbl){
			psp2chUTF82Sjis(strbuf, menuList[i]);
		} else {
			strcpy(strbuf, menuList[i]);
		}
		if (i == menu.select){
			pgFillvram(s2ch.menuWinColor.s_bg, x, winParam->pgCursorY, width, LINE_PITCH, 2);
			if (menuCor[i]){									// fBNgp
				pgPrint(strbuf, s2ch.menuWinColor.dir, s2ch.menuWinColor.s_bg, x + width);
			} else {											// t@Cp
				pgPrint(strbuf, s2ch.menuWinColor.s_text, s2ch.menuWinColor.s_bg, x + width);
			}
		} else {
			if (menuCor[i]){									// fBNgp
				pgPrint(strbuf, s2ch.menuWinColor.dir, s2ch.menuWinColor.bg, x + width);
			} else {											// t@Cp
				pgPrint(strbuf, s2ch.menuWinColor.text, s2ch.menuWinColor.bg, x + width);
			}
		}
		pgSetDrawStart(x, -1, 0, LINE_PITCH);
	}
}

/****************
t@CXg
****************/

#define MENU_MP3FILE_WIDTH (440)
#define MENU_MP3FILE_ITEM (18)
int psp2chMenuPlayer(char* base)
{
	static S_2CH_SCREEN	menu;
    SceIoStat			stats;
    char				path[FILE_PATH], file[FILE_PATH];
    char				**menuList = NULL;
    int					**menuCor = NULL;
//    char* menuStr = s2ch.menuWin[winParam->tateFlag].main, *p;
	char				*p,menuStr[128];
    int					lineEnd = MENU_MP3FILE_ITEM, change = 1;
    int					i, startX, startY, scrX, scrY;
	int					picMenu = 1, thumbFlag;
    
	strcpy(menuStr, s2ch.menuWin[winParam->tateFlag].main);
	strcat(menuStr, "         : BGM~         : j[");	// L[KC_Xǉ
    if (base)
    	strcpy(path, base);
    else
    	strcpy(path, s2ch.cwDir);
    menu.count = psp2chMenuGetDir(path, &menuList, &menuCor);
    strcpy(file, path);
    
    if(menu.count < 0)
    	return -1;
    startX = (winParam->width - MENU_MP3FILE_WIDTH) / 2;
    startY = (winParam->height - LINE_PITCH * lineEnd) / 2;
    scrX = MENU_MP3FILE_WIDTH;
    scrY = LINE_PITCH * lineEnd;
    menu.start = 0;
    menu.select = 0;
    if (menu.select >= MENU_MP3FILE_ITEM)
    {
        menu.start = menu.select - MENU_MP3FILE_ITEM + 1;
    }
    
    while (s2ch.running)
    {
        if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
        {
        	if (change)
			{
	            psp2chDrawMenu2((char**)menuList, menuCor, menu, startX, startY, scrX, scrY);
				pgPrintMenuBar(menuStr);
			}
            psp2chCursorSet(&menu, lineEnd, 0, 0, &change);
            if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
            {
                s2ch.oldPad = s2ch.pad;
                if (s2ch.pad.Buttons & s2ch.menuWin[winParam->tateFlag].ok)
                {
                	strcpy( file, path );
                	strcat( file, "/" );
                	strcat( file, menuList[menu.select] );
//                	sprintf(file, "%s/%s", path, menuList[menu.select]);
                	sceIoGetstat(file, &stats);
                	if ((stats.st_mode & FIO_S_IFDIR) || strcmp(menuList[menu.select], "..") == 0)
                	{
                		// 
                		if (strcmp(menuList[menu.select], "..") == 0)
                		{
                			p = strrchr(path, '/');
                			*p = '\0';
                		}
                		else
                			strcpy(path, file);
                		for (i = 0; i < menu.count; i++)
    					{
        					free(menuList[i]);
    					}
    					free(menuList);
    					free(menuCor);
    					menu.count = psp2chMenuGetDir(path, &menuList, &menuCor);
    					if(menu.count < 0)
    						return -1;
    					menu.start = 0;
    					menu.select = 0;
    					if (menu.select >= MENU_MP3FILE_ITEM)
    					{
        					menu.start = menu.select - MENU_MP3FILE_ITEM + 1;
    					}
                	}
                	else
                	{
						thumbFlag = -1;
						while (s2ch.running){					// 摜p[v
							int type,next;
	                		p = strrchr(menuList[menu.select], '.');
							type = 0;								// 0:̑ 1:摜t@C
	                		if(p)
	                		{
		                		if (stricmp(p, ".mp3") == 0)
		                		{
				               		psp2chAudioPlay(path, menuList[menu.select]);
								}
								if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0)
								{
									psp2chMenuImageView(file, stats.st_size, &picMenu, &thumbFlag, 0);
									type = 1;
								}
								if (stricmp(p, ".png") == 0)
								{
									psp2chMenuImageView(file, stats.st_size, &picMenu, &thumbFlag, 1);
									type = 1;
								}
								if (stricmp(p, ".gif") == 0)
								{
									psp2chMenuImageView(file, stats.st_size, &picMenu, &thumbFlag, 2);
									type = 1;
								}
								if (stricmp(p, ".bmp") == 0)
								{
									psp2chMenuImageView(file, stats.st_size, &picMenu, &thumbFlag, 3);
									type = 1;
								}
								if (stricmp(p, ".txt") == 0 || stricmp(p, ".ini") == 0 || stricmp(p, ".cfg") == 0){
									DrawImg	*image;
									image = ScreenCopy();			// ʃC[Wۑ
									SMEMOfile( file );				// wt@CPSPŊJ
									pgSetupGu();
									ScreenPaste(image);				// ʃC[W𕜌
									flipScreen(0);
									pgReDraw();
									pgCursorColorSet();				// J[\C[WĐݒ
								}
							}
							if (type && (s2ch.pad.Buttons & PSP_CTRL_RTRIGGER ||
							             s2ch.pad.Buttons & PSP_CTRL_LTRIGGER)){	// 摜
								int	chKey;
								if (s2ch.cfg.keySwap){								// 摜L[̓ւ
									chKey = PSP_CTRL_LTRIGGER;
								} else {
									chKey = PSP_CTRL_RTRIGGER;
								}
								if (s2ch.pad.Buttons & chKey){						// ̉摜
									next = -1;
									menu.select++;
									if (menu.select>=menu.count) menu.select = 0;
									while (next==-1){								// ̉摜t@CT
										for (i=menu.select; i<menu.count ;i++){
											p = strrchr(menuList[i], '.');
											if(p){
												if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0 ||
												    stricmp(p, ".png") == 0 ||
												    stricmp(p, ".gif") == 0 ||
												    stricmp(p, ".bmp") == 0){
													next = i;
													break;
												}
											}
										}
										if (next==-1) menu.select = 0;				// 摜Ȃΐ擪ɖ߂Ă蒼
									}
								} else {											// Ỏ摜
									next = -1;
									menu.select--;
									if (menu.select<0) menu.select = menu.count -1;
									while (next==-1){								// Ỏ摜t@CT
										for (i=menu.select; i>=0 ;i--){
											p = strrchr(menuList[i], '.');
											if(p){
												if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0 ||
												    stricmp(p, ".png") == 0 ||
												    stricmp(p, ".gif") == 0 ||
												    stricmp(p, ".bmp") == 0){
													next = i;
													break;
												}
											}
										}
										if (next==-1) menu.select = menu.select = menu.count -1;	// 摜Ȃ΍Ōɖ߂Ă蒼
									}
								}
								menu.select = next;				// ɕ\摜
								sprintf(file, "%s/%s", path, menuList[menu.select]);
								sceIoGetstat(file, &stats);
							} else {
								if (menu.select<menu.start) menu.start = menu.select;
								if (menu.select>menu.start+MENU_MP3FILE_ITEM-1) menu.start = menu.select - MENU_MP3FILE_ITEM + 1;
								break;							// 摜Ƃ͊֌WȂ̂Ń[vI
							}
						}
					}
					change = 1;
				}
				else if (s2ch.pad.Buttons & s2ch.menuWin[winParam->tateFlag].esc)
				{
					DrawImg	*image;
					int		ret;
					image = ScreenCopy();						// ʃC[Wۑ
					ret = psp2chErrorDialog(1, "I܂H");
					ScreenPaste(image);							// ʃC[W𕜌
					if (ret == PSP_UTILITY_MSGDIALOG_RESULT_YES){
						s2ch.running = 0;
						break;
					}
					change = 1;
				}
				else if (s2ch.pad.Buttons & PSP_CTRL_TRIANGLE)
				{
					DrawImg	*image;
					int		ret;
					image = ScreenCopy();						// ʃC[Wۑ
					ret = psp2chMenuFileCtrl(path, menuList[menu.select], menuCor[menu.select]);
					ScreenPaste(image);							// ʃC[W𕜌
					flipScreen(0);
					pgReDraw();
					if (ret){
						for (i = 0; i < menu.count; i++)		// t@Czuω̂ōĎ擾
						{
							free(menuList[i]);
						}
						free(menuList);
						free(menuCor);
						menu.count = psp2chMenuGetDir(path, &menuList, &menuCor);
						if(menu.count < 0)
							return -1;
						if (menu.select>=menu.count) menu.select = menu.count - 1;
						if (menu.start>menu.select) menu.start = menu.select;
					}
					change = 1;
				}
                else if(s2ch.pad.Buttons & PSP_CTRL_SQUARE)
                {
                	psp2chAudioStop();
                	strcpy(file, path);
                }
            }
			
			pgDrawTexture(-1);
			pgWindowFrame(startX, startY, startX + scrX, startY + scrY);
			pgCopyMenuBar();
			flipScreen(0);
        }
    }
    for (i = 0; i < menu.count; i++)
    {
        free(menuList[i]);
    }
    free(menuList);
    free(menuCor);
	return 0;
}

/*************************************
fBNg擾
*************************************/
int psp2chMenuGetDir(const char* file, char ***list,int **cor)
{
    SceUID fd;
    SceIoDirent dir;
    int i, j, count = 0;
    char **menuList,**buf,path[1024];
	int *menuCor,buf2;
    
    strcpy( path, file );
    if (path[strlen(path)-1]=='\\') strcat(path,"\\");
    if ((fd = sceIoDopen(path)) < 0)							// path̍Ō'\'Ƃȓc?
    {
    	psp2chNormalError(DIR_MAKE_ERR, file);
    	return -1;
    }
    memset(&dir, 0, sizeof(dir)); // ȂreadɎs
    while (sceIoDread(fd, &dir) > 0)
    {
    	if(strcmp(dir.d_name, ".") == 0)
    	{
    		continue;
    	}
        count++;
    }
    sceIoDclose(fd);
    menuList = (char**)malloc(sizeof(char*) * count);
    if (menuList == NULL)
    {
        psp2chNormalError(MEM_ALLC_ERR, "menuList");
        return -1;
    }
    menuCor = (int*)malloc(sizeof(int) * count);
    if (menuCor == NULL){
		free(menuList);
		psp2chNormalError(MEM_ALLC_ERR, "menuList");
		return -1;
	}
    if ((fd = sceIoDopen(path)) < 0)
    {
        free(menuList);
        free(menuCor);
        psp2chNormalError(DIR_MAKE_ERR, file);
        return -1;
    }
    i = 0;
    memset(&dir, 0, sizeof(dir));
    while (sceIoDread(fd, &dir) > 0)
    {
    	if(strcmp(dir.d_name, ".") == 0)
    	{
    		continue;
    	}
        buf = (char*)malloc(sizeof(char) * (strlen(dir.d_name) + 1));
		if (buf==NULL) break;									// ȂI
		menuList[i] = buf;
		if (dir.d_stat.st_attr & FIO_SO_IFDIR){					// fBNgHt@CH
			menuCor[i] = -1;									// fBNg
		} else {
			menuCor[i] = 0;										// t@C
		}
        strcpy(menuList[i], dir.d_name);
        i++;
        if (i >= count)
        {
            break;
        }
    }
    sceIoDclose(fd);
	if (s2ch.cfg.fileSort){										// t@Cz\[g
		for (i=1; i<count-1 ;i++){
			for (j=i+1; j<count ;j++){
				if (strcmp(menuList[i],menuList[j])>0 && menuCor[i]==menuCor[j] || !menuCor[i] && menuCor[j]){
					buf = menuList[i];
					menuList[i] = menuList[j];
					menuList[j] = buf;
					buf2 = menuCor[i];
					menuCor[i] = menuCor[j];
					menuCor[j] = buf2;
				}
			}
		}
	}
    *list = menuList;
	*cor = menuCor;
    return count;
}


//==============================================================
// fBNg폜
//--------------------------------------------------------------
// w肳ꂽfBNgt@C܂߂č폜B
// ɂTufBNg폜܂B
//--------------------------------------------------------------

static void removeDir(char *path)
{
	SceIoDirent	dir;
	SceUID		fd;
	char		file[1024];

	if ((fd = sceIoDopen(path)) < 0) return;					// wfBNgJȂ̂ŏI
	memset(&dir, 0, sizeof(dir));								// ȂreadɎs
	while (sceIoDread(fd, &dir) > 0){
		if(strcmp(dir.d_name, ".") == 0) continue;
		if(strcmp(dir.d_name, "..") == 0) continue;
		strcpy( file, path );
		strcat( file, "/" );
		strcat( file, dir.d_name );
		if (dir.d_stat.st_attr & FIO_SO_IFDIR){					// fBNgHt@CH
			removeDir(file);									// fBNgiċAŃTufBNgj
		} else {
			sceIoRemove(file);									// t@C
		}
	}
	sceIoDclose(fd);
	sceIoRmdir(path);
}

/****************
t@C
****************/
#define FILE_CTRL_WIDTH (80)
#define FILE_CTRL_ITEM (6)
static int psp2chMenuFileCtrl(char* path, char* name, int status)
{
	static S_2CH_SCREEN menu;
	static int mode = 0; // Rs[Cړ̃[h
	static char mpath[FILE_PATH], mname[FILE_PATH]; // ̏ꏊ
    const char* menuList[] = {"Rs[", "ړ", "y[Xg", "l[", "폜","ŊJ"};
    const unsigned char title1[] = "Vt@C͂Ă";
    const char *text = "Vt@C";
    SceUID fd, dst;
    char file[FILE_PATH], old[FILE_PATH], buf[BUF_LENGTH];
    char* menuStr = s2ch.menuWin[winParam->tateFlag].main;
    int lineEnd = FILE_CTRL_ITEM, change = 1, size;
    int startX, startY, scrX, scrY,CHflag;

	menu.count = FILE_CTRL_ITEM;
    startX = (winParam->width - FILE_CTRL_WIDTH) / 2;
    startY = (winParam->height - LINE_PITCH * lineEnd) / 2;
    scrX = FILE_CTRL_WIDTH;
    scrY = LINE_PITCH * lineEnd;
    menu.start = 0;
    menu.select = 0;
    if (menu.select >= FILE_CTRL_ITEM)
    {
        menu.start = menu.select - FILE_CTRL_ITEM + 1;
    }
    
    CHflag = 0;													// t@CzɕύXHi0:Noj
    while (s2ch.running)
    {
        if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
        {
        	if (change)
			{
	            psp2chDrawMenu((char**)menuList, menu, startX, startY, scrX, scrY);
	            pgPrintMenuBar(menuStr);
			}
            psp2chCursorSet(&menu, lineEnd, 0, 0, &change);
            if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
            {
                s2ch.oldPad = s2ch.pad;
                if (s2ch.pad.Buttons & s2ch.menuWin[winParam->tateFlag].ok)
                {
                    switch (menu.select)
                    {
                	case 0:
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
                    	mode = 1;
                    	strcpy(mpath, path);
                    	strcpy(mname, name);
                    	break;
                    case 1:
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
                    	mode = 2;
                    	strcpy(mpath, path);
                    	strcpy(mname, name);
                        break;
                    case 2:
                    	if(!mode)
                    		break;
                    	sprintf(old, "%s/%s", mpath, mname);
                    	sprintf(file, "%s/%s", path, mname);
                    	if((fd = sceIoOpen(old, PSP_O_RDONLY, FILE_PARMISSION)) < 0)
                    	{
                    		psp2chNormalError(FILE_OPEN_ERR, old);
                    		break;
                    	}
                    	if((dst = sceIoOpen(file, PSP_O_WRONLY | PSP_O_CREAT, FILE_PARMISSION)) < 0)
                    	{
                    		psp2chNormalError(FILE_OPEN_ERR, file);
                    		sceIoClose(fd);
                    		break;
                    	}
                    	while((size = psp2chFileRead(fd, buf, sizeof(buf))) > 0)
                    	{
	                    	psp2chFileWrite(dst, buf, size);
	                    }
	                    sceIoClose(fd);
	                    sceIoClose(dst);
						CHflag = -1;							// t@CzɕύX
	                    if(mode == 2)
	                    {
	                    	sceIoRemove(old);
	                    	strcpy(mpath, "");
	                    	strcpy(mname, "");
	                    }
	                    mode = 0;
                        break;
                    case 3:
						if (s2ch.cfg.hbl){
							psp2chUTF82Sjis(buf, name);
						} else {
							strcpy(buf, name);
						}
						if(psp2chInputDialog(title1, (char*)text, buf) == 0 && keyWords[0])
						{
							unsigned short	ucs[128];
							unsigned char	utf8[128];
							sprintf(old, "%s/%s", path, name);
							if (s2ch.cfg.hbl){
								psp2chSJIS2UCS(ucs, keyWords, 128);
								psp2chUCS2UTF8(utf8, ucs);
								sprintf(file, "%s/%s", path, utf8);
							} else {
								sprintf(file, "%s/%s", path, keyWords);
							}
							sceIoRename(old, file);
							CHflag = -1;						// t@CzɕύX
						}
                        break;
                    case 4:										// 폜
						sprintf(file, "%s/%s", path, name);
						if (s2ch.cfg.hbl){
							psp2chUTF82Sjis(buf, file);
						} else {
							strcpy(buf, file);
						}
						if (status){							// ΏۂfBNg
							if (psp2chErrorDialog(2, "%s\n̓tH_ł\nt@CiTutH_܂ށj܂߂č폜܂낵ł", 
											buf) == PSP_UTILITY_MSGDIALOG_RESULT_YES){
								removeDir(file);
								CHflag = -1;					// t@CzɕύX
							}
						} else {								// Ώۂt@C
							if (psp2chErrorDialog(2, "%s\n%s", buf, FILE_TXT_1) == PSP_UTILITY_MSGDIALOG_RESULT_YES)
							{
								sceIoRemove(file);
								CHflag = -1;					// t@CzɕύX
							}
						}
                    	break;
                    case 5:										// ŊJ
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
						sprintf(file, "%s/%s", path, name);
						SMEMOfile( file );						// wt@CPSPŊJ
						pgSetupGu();
						pgCursorColorSet();						// J[\C[WĐݒ
						break;
                    }
					change = 1;
                    break;
                }
                else if (s2ch.pad.Buttons & s2ch.menuWin[winParam->tateFlag].esc)
                {
                    break;
                }
            }
			
			pgDrawTexture(1);
			pgCopyWindow(0, startX, startY, scrX, scrY);
			pgWindowFrame(startX, startY, startX + scrX, startY + scrY);
			pgCopyMenuBar();
			flipScreen(0);
        }
    }
    return CHflag;
}

